/*******************************************************************************
*  skSPIlib.h - SPIʐMs֐̃CN[ht@C(16rbgMCUp)       *
*               (PIC 24EP256MC202) PIC24F(24FJ64GB002)                         *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2015-07-30  ޒH[            Create                            *
*  1.10    2016-06-14  ޒH[(ނ)  SPI_MODECKE(NbNʑ)ύX *
*  1.20    2019-01-08  ޒH[(ނ)  PIC24FmF                    *
*******************************************************************************/
#ifndef _SKSPILIB_H_
#define _SKSPILIB_H_


// 萔̒`
#ifndef LOW
#define LOW  0
#endif
#ifndef HIGH
#define HIGH 1
#endif

#define SPI_MODE1 1           // NbNɐ(0:LOW)  NbNʑ(0:ACh0VŁA0V->5Vɕωœ])
#define SPI_MODE0 0           // NbNɐ(0:LOW)  NbNʑ(1:ACh0VŁA5V->0Vɕωœ])
#define SPI_MODE3 3           // NbNɐ(1:HIGH) NbNʑ(0:ACh5VŁA5V->0Vɕωœ])
#define SPI_MODE2 2           // NbNɐ(1:HIGH) NbNʑ(1:ACh5VŁA0V->5Vɕωœ])
#define SPI_PPRE_DIV1    3    // vC}vXP[̕  1:1
#define SPI_PPRE_DIV4    2    // vC}vXP[̕  4:1
#define SPI_PPRE_DIV16   1    // vC}vXP[̕  16:1
#define SPI_PPRE_DIV64   0    // vC}vXP[̕  64:1
#define SPI_SPRE_DIV1    7    // ZJ_vXP[̕  1:1
#define SPI_SPRE_DIV2    6    // ZJ_vXP[̕  2:1
#define SPI_SPRE_DIV3    5    // ZJ_vXP[̕  3:1
#define SPI_SPRE_DIV4    4    // ZJ_vXP[̕  4:1
#define SPI_SPRE_DIV5    3    // ZJ_vXP[̕  5:1
#define SPI_SPRE_DIV6    2    // ZJ_vXP[̕  6:1
#define SPI_SPRE_DIV7    1    // ZJ_vXP[̕  7:1
#define SPI_SPRE_DIV8    0    // ZJ_vXP[̕  8:1

//#define SPI_MSSP2_USE         // SPI2𗘗pꍇ̓RgO܂B
// rohW[̃WX^[`
#ifdef  SPI_MSSP2_USE
// SPI2(MSSP2)𗘗pꍇ̒`
#define SPI_CON1         SPI2CON1
#define SPI_BUF          SPI2BUF
#define SPI_IF           _SPI2IF
#define SPI_STAT_SPIEN   SPI2STATbits.SPIEN
#else
// SPI1(MSSP1)𗘗pꍇ̒`
#define SPI_CON1         SPI1CON1
#define SPI_BUF          SPI1BUF
#define SPI_IF           _SPI1IF
#define SPI_STAT_SPIEN   SPI1STATbits.SPIEN
#endif

// ֐̃vg^Cv錾
void SPI_Init(char mode,char divider,int sdo) ;
void SPI_setDataMode(char mode) ;
void SPI_setClockDivider(char divider1,char divider2) ;
unsigned char SPI_transfer(char dt) ;


#endif
